//xsetaseta@gmail.com
//Libreria RF24master  Copyright (C) 2011 J. Coliz <maniacbug@ymail.com>
//    17/11/2017
  #include <SPI.h> 
  #include <nRF24L01.h>
  #include <RF24.h>

  #define CE 8
  #define CSN 7

  RF24 radio(CE, CSN);

  const uint64_t tuberia = 0xE8E8F0F0E1LL;
  char dato[20];

  #define PIN_D02 2
  #define PIN_D03 3
  #define PIN_D04 4
  #define PIN_D05 5
  
  #define PIN_V1 9
  #define PIN_V2 10
  
  bool done;
  int z,anterior;
  
  byte SENSOR0,SENSOR1,SENSOR2,SENSOR3 ;
  byte ENTRADAS;
  
void setup() 
  {
    Serial.begin(9600);
    Serial.println("Receptor mando1");
    radio.begin();
    radio.setChannel(50);  
    radio.openReadingPipe(1, tuberia); 
    radio.startListening(); 
    pinMode(PIN_D02,OUTPUT);
    pinMode(PIN_D03,OUTPUT);
    pinMode(PIN_D04,OUTPUT);
    pinMode(PIN_D05,OUTPUT);
  
    digitalWrite(PIN_D02, HIGH);
    digitalWrite(PIN_D03, HIGH);
    digitalWrite(PIN_D04, HIGH);
    digitalWrite(PIN_D05, HIGH); 
    
   // digitalWrite(PIN_V1, HIGH);
   // digitalWrite(PIN_V2, HIGH); 
    
   // analogWrite(PIN_V1,255);
   // analogWrite(PIN_V2,255);
  }
  
void loop(void)
{ 
  delay(1);
  
  z++;
  if(z>300)
  {    
    digitalWrite(PIN_D02, HIGH);
    digitalWrite(PIN_D03, HIGH);
    digitalWrite(PIN_D04, HIGH);
    digitalWrite(PIN_D05, HIGH);
    z=0;
  }
   
   
  while(radio.available()) 
    {
      radio.read(dato, 7);
      SENSOR0=dato[0]; SENSOR1=dato[1];
      SENSOR2=dato[2]; SENSOR3=dato[3];
      ENTRADAS=dato[4];

      Serial.print(ENTRADAS,BIN);  Serial.print(" ");
      Serial.print(SENSOR0);Serial.print(" "); Serial.print(SENSOR1); Serial.print(" ");
      Serial.print(SENSOR2);Serial.print(" "); Serial.println(SENSOR3);           
      done=1;  
    }
 
 
 if (done)
      { 
      //Parar        
      if(SENSOR1>120 && SENSOR1<136 && SENSOR0>120 && SENSOR0<136 )
        {
          anterior=0;
          digitalWrite(PIN_D02, HIGH);
          digitalWrite(PIN_D03, HIGH);
          digitalWrite(PIN_D04, HIGH);
          digitalWrite(PIN_D05, HIGH);
          z=0;
        }
        
       //Adelante
       if(SENSOR1<64)
     {
           digitalWrite(PIN_D02, HIGH);
           digitalWrite(PIN_D03, LOW);
           digitalWrite(PIN_D04, HIGH);
           digitalWrite(PIN_D05, LOW);
           if(anterior==0)
             {
               analogWrite(9,255);
               analogWrite(10,255);
               anterior=1;
               delay(90);
             }
           if(SENSOR0>192)
               analogWrite(9,64);
             else
               analogWrite(9,SENSOR2);
           if(SENSOR0<64)
               analogWrite(10,64);
             else    
               analogWrite(10,SENSOR2);
           
           z=0; 
           goto salto;
        }
        
        //Atras
         if(SENSOR1>192)
        {
           digitalWrite(PIN_D02, LOW);
           digitalWrite(PIN_D03, HIGH);
           digitalWrite(PIN_D04, LOW);
           digitalWrite(PIN_D05, HIGH);
           if(anterior==0)
             {
               analogWrite(9,255);
               analogWrite(10,255);
               anterior=1;
               delay(90);
             }
           analogWrite(9,SENSOR2);
           analogWrite(10,SENSOR2);
           
           z=0;
           goto salto;
        }
        
        //Izquierda
       if(SENSOR0<64)
        {
           analogWrite(9,255);
           analogWrite(10,255);
           digitalWrite(PIN_D02, HIGH);
           digitalWrite(PIN_D03, LOW);     
           digitalWrite(PIN_D04, LOW);
           digitalWrite(PIN_D05, HIGH);
           if(ENTRADAS & 4)
               delay(100);
             else
               delay(50);
           analogWrite(9,0);
           analogWrite(10,0);
           delay(300);
           z=0;
           goto salto;
           
        }
        
        
        //Derecha
        if(SENSOR0>192)
        {  
           analogWrite(9,255);
           analogWrite(10,255);       
           digitalWrite(PIN_D02, LOW); 
           digitalWrite(PIN_D03, HIGH);
           digitalWrite(PIN_D04, HIGH);
           digitalWrite(PIN_D05, LOW);
           if(ENTRADAS & 4)
               delay(100);
             else
               delay(50);
           analogWrite(9,0);
           analogWrite(10,0);
           delay(300);        
           z=0;
           goto salto;
        }
      ;
salto:
        done=0;
      }
 
 
}

